local e=require"luci.tools.webadmin"
local r=require"luci.model.network"
local w=require"luci.util"
local c=require"luci.sys".net
local d=require"nixio.fs"
arg[1]=arg[1]or""
m=Map("wireless","",
translate("The <em>Device Configuration</em> section covers physical settings of the radio "..
"hardware such as channel, transmit power or antenna selection which are shared among all "..
"defined wireless networks (if the radio hardware is multi-SSID capable). Per network settings "..
"like encryption or operation mode are grouped in the <em>Interface Configuration</em>."))
m:chain("network")
m:chain("firewall")
m.redirect=luci.dispatcher.build_url("admin/network/wireless")
local f
function m.on_commit(e)
local e=r:get_wifinet(arg[1])
if f and e then
f.section=e.sid
m.title=luci.util.pcdata(e:get_i18n())
end
end
r.init(m.uci)
local i=r:get_wifinet(arg[1])
local t=i and i:get_device()
if not i or not t then
luci.http.redirect(luci.dispatcher.build_url("admin/network/wireless"))
return
end
function m.parse(o)
local e=m:formvalue("cbid.wireless.%s.country"%t:name())
local a=m:get(t:name(),"country")
if m:formvalue("cbid.wireless.%s.__toggle"%t:name())then
if t:get("disabled")=="1"or i:get("disabled")=="1"then
i:set("disabled",nil)
else
i:set("disabled","1")
end
t:set("disabled",nil)
r:commit("wireless")
luci.sys.call("(env -i /bin/ubus call network reload) >/dev/null 2>/dev/null")
luci.http.redirect(luci.dispatcher.build_url("admin/network/wireless",arg[1]))
return
end
Map.parse(o)
if m:get(t:name(),"type")=="mac80211"and e and e~=a then
luci.sys.call("iw reg set %q"%e)
luci.http.redirect(luci.dispatcher.build_url("admin/network/wireless",arg[1]))
return
end
end
m.title=luci.util.pcdata(i:get_i18n())
local function h(e)
local t=e.txpwrlist or{}
local a=tonumber(e.txpower_offset)or 0
local e={}
local o=-1
local i,i
for i,t in ipairs(t)do
local i=t.dbm+a
local a=math.floor(10^(i/10))
if a~=o then
o=a
e[#e+1]={
display_dbm=i,
display_mw=a,
driver_dbm=t.dbm,
driver_mw=t.mw
}
end
end
return e
end
local function l(e,t)
e=tonumber(e)
if e~=nil then
local a,a
for a,t in ipairs(t)do
if t.driver_dbm>=e then
return t.driver_dbm
end
end
end
return e or""
end
local n=luci.sys.wifi.getiwinfo(arg[1])
local a=n.hwmodelist or{}
local o=h(n)
local u=l(t:get("txpower"),o)
s=m:section(NamedSection,t:name(),"wifi-device",translate("Device Configuration"))
s.addremove=false
s:tab("general",translate("General Setup"))
s:tab("macfilter",translate("MAC-Filter"))
s:tab("advanced",translate("Advanced Settings"))
st=s:taboption("general",DummyValue,"__status",translate("Status"))
st.template="admin_network/wifi_status"
st.ifname=arg[1]
en=s:taboption("general",Button,"__toggle")
if t:get("disabled")=="1"or i:get("disabled")=="1"then
en.title=translate("Wireless network is disabled")
en.inputtitle=translate("Enable")
en.inputstyle="apply"
else
en.title=translate("Wireless network is enabled")
en.inputtitle=translate("Disable")
en.inputstyle="reset"
end
local e=t:get("type")
local h=t:get("antenna")
local h=nil
local y,y
if i:mode()~="sta"then
for t,e in ipairs(t:get_wifinets())do
if e:mode()=="sta"and e:get("disabled")~="1"then
if not h then
h={}
h.channel=e:channel()
h.names={}
end
h.names[#h.names+1]=e:shortname()
end
end
end
if h then
ch=s:taboption("general",DummyValue,"choice",translate("Channel"))
ch.value=translatef("Locked to channel %s used by: %s",
h.channel or"(auto)",table.concat(h.names,", "))
else
ch=s:taboption("general",Value,"_mode_freq",'<br />'..translate("Operating frequency"))
ch.hwmodes=a
ch.htmodes=n.htmodelist
ch.freqlist=n.freqlist
ch.template="cbi/wireless_modefreq"
function ch.cfgvalue(t,e)
return{
m:get(e,"hwmode")or"",
m:get(e,"channel")or"auto",
m:get(e,"htmode")or""
}
end
function ch.formvalue(t,e)
return{
m:formvalue(t:cbid(e)..".band")or(a.g and"11g"or"11a"),
m:formvalue(t:cbid(e)..".channel")or"auto",
m:formvalue(t:cbid(e)..".htmode")or""
}
end
function ch.write(a,t,e)
m:set(t,"hwmode",e[1])
m:set(t,"channel",e[2])
m:set(t,"htmode",e[3])
end
end
if e=="mac80211"then
if#o>0 then
tp=s:taboption("general",ListValue,
"txpower",translate("Transmit Power"),"dBm")
tp.rmempty=true
tp.default=u
function tp.cfgvalue(...)
return l(Value.cfgvalue(...),o)
end
tp:value("",translate("auto"))
for t,e in ipairs(o)do
tp:value(e.driver_dbm,"%i dBm (%i mW)"
%{e.display_dbm,e.display_mw})
end
end
local e=n and n.countrylist
if e and#e>0 then
cc=s:taboption("advanced",ListValue,"country",translate("Country Code"),translate("Use ISO/IEC 3166 alpha2 country codes."))
cc.default=tostring(n and n.country or"00")
for t,e in ipairs(e)do
cc:value(e.alpha2,"%s - %s"%{e.alpha2,e.name})
end
else
s:taboption("advanced",Value,"country",translate("Country Code"),translate("Use ISO/IEC 3166 alpha2 country codes."))
end
s:taboption("advanced",Value,"distance",translate("Distance Optimization"),
translate("Distance to farthest network member in meters."))
local e=n and n.extant
if e and#e>0 then
ea=s:taboption("advanced",ListValue,"extant",translate("Antenna Configuration"))
for t,e in ipairs(e)do
ea:value(e.id,"%s (%s)"%{e.name,e.description})
if e.selected then
ea.default=e.id
end
end
end
s:taboption("advanced",Value,"frag",translate("Fragmentation Threshold"))
s:taboption("advanced",Value,"rts",translate("RTS/CTS Threshold"))
end
if e=="qcawifi"then
if#o>0 then
tp=s:taboption("general",ListValue,
"txpower",translate("Transmit Power"),"dBm")
tp.rmempty=true
tp.default=u
function tp.cfgvalue(...)
return l(Value.cfgvalue(...),o)
end
tp:value("",translate("auto"))
for t,e in ipairs(o)do
tp:value(e.driver_dbm,"%i dBm (%i mW)"
%{e.display_dbm,e.display_mw})
end
end
s:taboption("advanced",Flag,"noscan",translate("Force HT40/VHT80"))
s:taboption("advanced",Flag,"mucapwar",translate("Disable MU-MIMO for Broadcom Device"))
if a.g then
s:taboption("advanced",Flag,"vht11ng",translate("VHT40(256QAM) Support"))
end
s:taboption("advanced",Flag,"qboost",translate("TDMA Support"))
s:taboption("advanced",Flag,"txburst",translate("Tx Burst"))
s:taboption("advanced",Flag,"greenap",translate("Green AP"))
s:taboption("advanced",Flag,"greenfield",translate("HT-Greenfield"))
s:taboption("advanced",Flag,"bndstrg",translate("Band Steering"))
country=s:taboption("advanced",Value,"country",translate("Country Code"))
country:value("US",translate("United States"))
country:value("CN",translate("China"))
country:value("RU",translate("Russia"))
country:value("EU",translate("Europe"))
country:value("AU",translate("Australia"))
country:value("00",translate("World"))
s:taboption("advanced",Value,"maxassoc",translate("Connection Limit"))
s:taboption("advanced",Value,"frag",translate("Fragmentation Threshold"))
s:taboption("advanced",Value,"rts",translate("RTS/CTS Threshold"))
end
if e=="broadcom"then
tp=s:taboption("general",
(#o>0)and ListValue or Value,
"txpower",translate("Transmit Power"),"dBm")
tp.rmempty=true
tp.default=u
function tp.cfgvalue(...)
return l(Value.cfgvalue(...),o)
end
tp:value("",translate("auto"))
for t,e in ipairs(o)do
tp:value(e.driver_dbm,"%i dBm (%i mW)"
%{e.display_dbm,e.display_mw})
end
mode=s:taboption("advanced",ListValue,"hwmode",translate("Band"))
if a.b then
mode:value("11b","2.4GHz (802.11b)")
if a.g then
mode:value("11bg","2.4GHz (802.11b+g)")
end
end
if a.g then
mode:value("11g","2.4GHz (802.11g)")
mode:value("11gst","2.4GHz (802.11g + Turbo)")
mode:value("11lrs","2.4GHz (802.11g Limited Rate Support)")
end
if a.a then mode:value("11a","5GHz (802.11a)")end
if a.n then
if a.g then
mode:value("11ng","2.4GHz (802.11g+n)")
mode:value("11n","2.4GHz (802.11n)")
end
if a.a then
mode:value("11na","5GHz (802.11a+n)")
mode:value("11n","5GHz (802.11n)")
end
htmode=s:taboption("advanced",ListValue,"htmode",translate("HT mode (802.11n)"))
htmode:depends("hwmode","11ng")
htmode:depends("hwmode","11na")
htmode:depends("hwmode","11n")
htmode:value("HT20","20MHz")
htmode:value("HT40","40MHz")
end
ant1=s:taboption("advanced",ListValue,"txantenna",translate("Transmitter Antenna"))
ant1.widget="radio"
ant1:depends("diversity","")
ant1:value("3",translate("auto"))
ant1:value("0",translate("Antenna 1"))
ant1:value("1",translate("Antenna 2"))
ant2=s:taboption("advanced",ListValue,"rxantenna",translate("Receiver Antenna"))
ant2.widget="radio"
ant2:depends("diversity","")
ant2:value("3",translate("auto"))
ant2:value("0",translate("Antenna 1"))
ant2:value("1",translate("Antenna 2"))
s:taboption("advanced",Flag,"frameburst",translate("Frame Bursting"))
s:taboption("advanced",Value,"distance",translate("Distance Optimization"))
s:taboption("advanced",Value,"country",translate("Country Code"))
s:taboption("advanced",Value,"maxassoc",translate("Connection Limit"))
end
if e=="rtwifi"or e=="mt_dbdc"then
tp=s:taboption("general",
(#o>0)and ListValue or Value,
"txpower",translate("Transmit Power"),translate("Depends on factory set"))
tp.rmempty=true
tp.default=u
tp:value("1","1%")
tp:value("3","3%")
tp:value("12","12%")
tp:value("25","25%")
tp:value("30","30%")
tp:value("50","50%")
tp:value("75","75%")
tp:value("100","100%")
s:taboption("advanced",Flag,"noscan",translate("Force HT40/VHT80"))
s:taboption("advanced",Flag,"txburst",translate("Tx Burst"))
s:taboption("advanced",Flag,"smart",translate("SmartWiFi"))
s:taboption("advanced",Flag,"greenap",translate("Green AP"))
s:taboption("advanced",Flag,"greenfield",translate("HT-Greenfield"))
s:taboption("advanced",Flag,"bndstrg",translate("Band Steering"))
country=s:taboption("advanced",Value,"country",translate("Country Code"))
country:value("US",translate("United States"))
country:value("CN",translate("China"))
country:value("RU",translate("Russia"))
country:value("EU",translate("Europe"))
country:value("AU",translate("Australia"))
country:value("00",translate("World"))
s:taboption("advanced",Value,"maxassoc",translate("Connection Limit"))
s:taboption("advanced",Value,"frag",translate("Fragmentation Threshold"))
s:taboption("advanced",Value,"rts",translate("RTS/CTS Threshold"))
end
if e=="prism2"then
s:taboption("advanced",Value,"txpower",translate("Transmit Power"),"att units").rmempty=true
s:taboption("advanced",Flag,"diversity",translate("Diversity")).rmempty=false
s:taboption("advanced",Value,"txantenna",translate("Transmitter Antenna"))
s:taboption("advanced",Value,"rxantenna",translate("Receiver Antenna"))
end
s=m:section(NamedSection,i.sid,"wifi-iface",translate("Interface Configuration"))
f=s
s.addremove=false
s.anonymous=true
s.defaults.device=t:name()
s:tab("general",translate("General Setup"))
s:tab("encryption",translate("Wireless Security"))
s:tab("macfilter",translate("MAC-Filter"))
s:tab("advanced",translate("Advanced Settings"))
ssid=s:taboption("general",Value,"ssid",translate("<abbr title=\"Extended Service Set Identifier\">ESSID</abbr>"))
ssid.datatype="maxlength(32)"
mode=s:taboption("general",ListValue,"mode",translate("Mode"))
mode.override_values=true
mode:value("ap",translate("Access Point"))
mode:value("sta",translate("Client"))
mode:value("adhoc",translate("Ad-Hoc"))
bssid=s:taboption("general",Value,"bssid",translate("<abbr title=\"Basic Service Set Identifier\">BSSID</abbr>"))
network=s:taboption("general",Value,"network",translate("Network"),
translate("Choose the network(s) you want to attach to this wireless interface or "..
"fill out the <em>create</em> field to define a new network."))
network.rmempty=true
network.template="cbi/network_netlist"
network.widget="checkbox"
network.novirtual=true
function network.write(o,a,t)
local e=r:get_interface(a)
if e then
if t=='-'then
t=m:formvalue(o:cbid(a)..".newnet")
if t and#t>0 then
local t=r:add_network(t,{proto="none"})
if t then t:add_interface(e)end
else
local t=e:get_network()
if t then t:del_interface(e)end
end
else
local a
for a,t in ipairs(e:get_networks())do
t:del_interface(e)
end
for t in w.imatch(t)do
local t=r:get_network(t)
if t then
if not t:is_empty()then
t:set("type","bridge")
end
t:add_interface(e)
end
end
end
end
end
if e=="mac80211"then
if d.access("/usr/sbin/iw")then
mode:value("mesh","802.11s")
end
mode:value("ahdemo",translate("Pseudo Ad-Hoc (ahdemo)"))
mode:value("monitor",translate("Monitor"))
bssid:depends({mode="adhoc"})
bssid:depends({mode="sta"})
bssid:depends({mode="sta-wds"})
mp=s:taboption("macfilter",ListValue,"macfilter",translate("MAC-Address Filter"))
mp:depends({mode="ap"})
mp:depends({mode="ap-wds"})
mp:value("",translate("disable"))
mp:value("allow",translate("Allow listed only"))
mp:value("deny",translate("Allow all except listed"))
ml=s:taboption("macfilter",DynamicList,"maclist",translate("MAC-List"))
ml.datatype="macaddr"
ml:depends({macfilter="allow"})
ml:depends({macfilter="deny"})
c.mac_hints(function(e,t)ml:value(e,"%s (%s)"%{e,t})end)
mode:value("ap-wds","%s (%s)"%{translate("Access Point"),translate("WDS")})
mode:value("sta-wds","%s (%s)"%{translate("Client"),translate("WDS")})
function mode.write(t,e,a)
if a=="ap-wds"then
ListValue.write(t,e,"ap")
m.uci:set("wireless",e,"wds",1)
elseif a=="sta-wds"then
ListValue.write(t,e,"sta")
m.uci:set("wireless",e,"wds",1)
else
ListValue.write(t,e,a)
m.uci:delete("wireless",e,"wds")
end
end
function mode.cfgvalue(e,t)
local e=ListValue.cfgvalue(e,t)
local t=m.uci:get("wireless",t,"wds")=="1"
if e=="ap"and t then
return"ap-wds"
elseif e=="sta"and t then
return"sta-wds"
else
return e
end
end
hidden=s:taboption("general",Flag,"hidden",translate("Hide <abbr title=\"Extended Service Set Identifier\">ESSID</abbr>"))
hidden:depends({mode="ap"})
hidden:depends({mode="ap-wds"})
wmm=s:taboption("general",Flag,"wmm",translate("WMM Mode"))
wmm:depends({mode="ap"})
wmm:depends({mode="ap-wds"})
wmm.default=wmm.enabled
isolate=s:taboption("advanced",Flag,"isolate",translate("Isolate Clients"),
translate("Prevents client-to-client communication"))
isolate:depends({mode="ap"})
isolate:depends({mode="ap-wds"})
ifname=s:taboption("advanced",Value,"ifname",translate("Interface name"),translate("Override default interface name"))
ifname.optional=true
end
if e=="qcawifi"then
mode:value("ap-wds","%s (%s)"%{translate("Access Point"),translate("WDS")})
mode:value("sta-wds","%s (%s)"%{translate("Client"),translate("WDS")})
mode:value("wds",translate("Static WDS"))
mode:value("qwrap",translate("QWRAP"))
function mode.write(a,e,t)
if t=="ap-wds"then
ListValue.write(a,e,"ap")
m.uci:set("wireless",e,"wds",1)
elseif t=="sta-wds"then
ListValue.write(a,e,"sta")
m.uci:set("wireless",e,"wds",1)
else
ListValue.write(a,e,t)
m.uci:delete("wireless",e,"wds")
end
end
function mode.cfgvalue(e,t)
local e=ListValue.cfgvalue(e,t)
local t=m.uci:get("wireless",t,"wds")=="1"
if e=="ap"and t then
return"ap-wds"
elseif e=="sta"and t then
return"sta-wds"
else
return e
end
end
bssid:depends({mode="wds"})
s:taboption("advanced",Flag,"doth","802.11h")
hidden=s:taboption("general",Flag,"hidden",translate("Hide <abbr title=\"Extended Service Set Identifier\">ESSID</abbr>"))
hidden:depends({mode="ap"})
hidden:depends({mode="ap-wds"})
hidden:depends({mode="sta-wds"})
isolate=s:taboption("advanced",Flag,"isolate",translate("Separate Clients"),
translate("Prevents client-to-client communication"))
isolate:depends({mode="ap"})
s:taboption("advanced",Flag,"uapsd",translate("Enable U-APSD"))
s:taboption("advanced",Value,"mcast_rate",translate("Multicast Rate"))
s:taboption("advanced",Value,"frag",translate("Fragmentation Threshold"))
s:taboption("advanced",Value,"rts",translate("RTS/CTS Threshold"))
s:taboption("advanced",Flag,"wmm",translate("WMM Mode"))
if a.ac then
s:taboption("advanced",Value,"nss",translate("Number of Spatial Streams"))
s:taboption("advanced",Flag,"ldpc",translate("LDPC"))
s:taboption("advanced",Flag,"rx_stbc",translate("RX STBC"))
s:taboption("advanced",Flag,"tx_stbc",translate("TX STBC"))
end
mp=s:taboption("macfilter",ListValue,"macfilter",translate("MAC-Address Filter"))
mp:value("",translate("disable"))
mp:value("allow",translate("Allow listed only"))
mp:value("deny",translate("Allow all except listed"))
ml=s:taboption("macfilter",DynamicList,"maclist",translate("MAC-List"))
ml:depends({macfilter="allow"})
ml:depends({macfilter="deny"})
c.mac_hints(function(e,t)ml:value(e,"%s (%s)"%{e,t})end)
end
if e=="broadcom"then
mode:value("wds",translate("WDS"))
mode:value("monitor",translate("Monitor"))
hidden=s:taboption("general",Flag,"hidden",translate("Hide <abbr title=\"Extended Service Set Identifier\">ESSID</abbr>"))
hidden:depends({mode="ap"})
hidden:depends({mode="adhoc"})
hidden:depends({mode="wds"})
isolate=s:taboption("advanced",Flag,"isolate",translate("Separate Clients"),
translate("Prevents client-to-client communication"))
isolate:depends({mode="ap"})
s:taboption("advanced",Flag,"doth","802.11h")
s:taboption("advanced",Flag,"wmm",translate("WMM Mode"))
bssid:depends({mode="wds"})
bssid:depends({mode="adhoc"})
end
if e=="prism2"then
mode:value("wds",translate("WDS"))
mode:value("monitor",translate("Monitor"))
hidden=s:taboption("general",Flag,"hidden",translate("Hide <abbr title=\"Extended Service Set Identifier\">ESSID</abbr>"))
hidden:depends({mode="ap"})
hidden:depends({mode="adhoc"})
hidden:depends({mode="wds"})
bssid:depends({mode="sta"})
mp=s:taboption("macfilter",ListValue,"macpolicy",translate("MAC-Address Filter"))
mp:value("",translate("disable"))
mp:value("allow",translate("Allow listed only"))
mp:value("deny",translate("Allow all except listed"))
ml=s:taboption("macfilter",DynamicList,"maclist",translate("MAC-List"))
ml:depends({macpolicy="allow"})
ml:depends({macpolicy="deny"})
c.mac_hints(function(e,t)ml:value(e,"%s (%s)"%{e,t})end)
s:taboption("advanced",Value,"rate",translate("Transmission Rate"))
s:taboption("advanced",Value,"frag",translate("Fragmentation Threshold"))
s:taboption("advanced",Value,"rts",translate("RTS/CTS Threshold"))
end
if e=="rtwifi"or e=="mt_dbdc"then
mode:value("wds",translate("WDS"))
s:taboption("general",DummyValue,"note_wds",translate("Note"),translate("WDS mode is only available between Ralink/MTK devices.")):depends({mode="wds"})
hidden=s:taboption("general",Flag,"hidden",translate("Hide <abbr title=\"Extended Service Set Identifier\">ESSID</abbr>"))
hidden:depends({mode="ap"})
hidden:depends({mode="adhoc"})
phymode=s:taboption("advanced",ListValue,"wdsphymode",translate("WDS PHY Mode"),translate("If GREENFIELD seems to be unstable,try to use OFDM instead.VHT is only available for 11AC devices."))
phymode:depends({mode="wds"})
phymode:value("CCK")
phymode:value("OFDM")
phymode:value("HTMIX")
phymode:value("GREENFIELD")
phymode:value("VHT")
phymode.default="GREENFIELD"
isolate=s:taboption("advanced",Flag,"isolated",translate("Separate Clients"),
translate("Prevents client-to-client communication"))
isolate:depends({mode="ap"})
if(tonumber(luci.sys.exec("lsmod | cut -d ' ' -f 1 | grep -c 'rt2860v2'")))==0 then
rssikick=s:taboption("advanced",Value,"rssikick",translate("Lowest RSSI for connected clients"),
translate("Set the lowest RSSI for connected clients.Clients with RSSI lower than this value will be kicked out.<br />Acceptable values: -100~0.Value '0' means disable."))
rssikick:depends({mode="ap"})
rssikick.datatype="range(-100,0)"
rssikick.default=0
rssiassoc=s:taboption("advanced",Value,"rssiassoc",translate("RSSI Limit for clients"),
translate("Set RSSI limit for clients.Clients with RSSI lower than this value won't be able to connect.<br />Acceptable values: -100~0.Value '0' means disable."))
rssiassoc:depends({mode="ap"})
rssiassoc.datatype="range(-100,0)"
rssiassoc.default=0
ieee80211r=s:taboption("encryption",Flag,"ieee80211r",
translate("802.11r Fast Transition"),
translate("Enables fast roaming among access points that belong "..
"to the same Mobility Domain"))
ieee80211r:depends({mode="ap",encryption="psk"})
ieee80211r:depends({mode="ap",encryption="psk2"})
ieee80211r:depends({mode="ap",encryption="psk-mixed"})
ieee80211r.rmempty=true
end
s:taboption("advanced",Flag,"doth","802.11h"):depends({mode="ap"})
s:taboption("advanced",Flag,"wmm",translate("WMM Mode")):depends({mode="ap"})
bssid:depends({mode="sta"})
bssid:depends({mode="wds"})
bssid:depends({mode="adhoc"})
ssid:depends({mode="sta"})
ssid:depends({mode="ap"})
ssid:depends({mode="adhoc"})
mp=s:taboption("macfilter",ListValue,"macpolicy",translate("MAC-Address Filter"))
mp:depends({mode="ap"})
mp:value("",translate("disable"))
mp:value("allow",translate("Allow listed only"))
mp:value("deny",translate("Allow all except listed"))
ml=s:taboption("macfilter",DynamicList,"maclist",translate("MAC-List"))
ml:depends({macpolicy="allow"})
ml:depends({macpolicy="deny"})
c.mac_hints(function(e,t)ml:value(e,"%s (%s)"%{e,t})end)
end
encr=s:taboption("encryption",ListValue,"encryption",translate("Encryption"))
encr.override_values=true
encr.override_depends=true
encr:depends({mode="ap"})
encr:depends({mode="sta"})
encr:depends({mode="adhoc"})
encr:depends({mode="ahdemo"})
encr:depends({mode="ap-wds"})
encr:depends({mode="sta-wds"})
encr:depends({mode="mesh"})
cipher=s:taboption("encryption",ListValue,"cipher",translate("Cipher"))
cipher:depends({encryption="wpa"})
cipher:depends({encryption="wpa2"})
cipher:depends({encryption="psk"})
cipher:depends({encryption="psk2"})
cipher:depends({encryption="wpa-mixed"})
cipher:depends({encryption="psk-mixed"})
cipher:value("auto",translate("auto"))
cipher:value("ccmp",translate("Force CCMP (AES)"))
cipher:value("tkip",translate("Force TKIP"))
cipher:value("tkip+ccmp",translate("Force TKIP and CCMP (AES)"))
function encr.cfgvalue(e,t)
local e=tostring(ListValue.cfgvalue(e,t))
if e=="wep"then
return"wep-open"
elseif e and e:match("%+")then
return(e:gsub("%+.+$",""))
end
return e
end
function encr.write(o,e,i)
local a=tostring(encr:formvalue(e))
local t=tostring(cipher:formvalue(e))
if i=="wpa"or i=="wpa2"then
o.map.uci:delete("wireless",e,"key")
end
if a and(t=="tkip"or t=="ccmp"or t=="tkip+ccmp")then
a=a.."+"..t
end
o.map:set(e,"encryption",a)
end
function cipher.cfgvalue(t,e)
local e=tostring(ListValue.cfgvalue(encr,e))
if e and e:match("%+")then
e=e:gsub("^[^%+]+%+","")
if e=="aes"then e="ccmp"
elseif e=="tkip+aes"then e="tkip+ccmp"
elseif e=="aes+tkip"then e="tkip+ccmp"
elseif e=="ccmp+tkip"then e="tkip+ccmp"
end
end
return e
end
function cipher.write(t,e)
return encr:write(e)
end
encr:value("none",translate("No Encryption"))
encr:value("wep-open",translate("WEP Open System"),{mode="ap"},{mode="sta"},{mode="ap-wds"},{mode="sta-wds"},{mode="adhoc"},{mode="ahdemo"},{mode="wds"})
encr:value("wep-shared",translate("WEP Shared Key"),{mode="ap"},{mode="sta"},{mode="ap-wds"},{mode="sta-wds"},{mode="adhoc"},{mode="ahdemo"},{mode="wds"})
if e=="qcawifi"or e=="mac80211"or e=="prism2"then
local t=d.access("/usr/sbin/wpa_supplicant")
local e=d.access("/usr/sbin/hostapd")
local o=(os.execute("hostapd -veap >/dev/null 2>/dev/null")==0)
local a=(os.execute("wpa_supplicant -veap >/dev/null 2>/dev/null")==0)
if e and t then
encr:value("psk","WPA-PSK",{mode="ap"},{mode="sta"},{mode="ap-wds"},{mode="sta-wds"},{mode="adhoc"})
encr:value("psk2","WPA2-PSK",{mode="ap"},{mode="sta"},{mode="ap-wds"},{mode="sta-wds"},{mode="adhoc"})
encr:value("psk-mixed","WPA-PSK/WPA2-PSK Mixed Mode",{mode="ap"},{mode="sta"},{mode="ap-wds"},{mode="sta-wds"},{mode="adhoc"})
if o and a then
encr:value("wpa","WPA-EAP",{mode="ap"},{mode="sta"},{mode="ap-wds"},{mode="sta-wds"})
encr:value("wpa2","WPA2-EAP",{mode="ap"},{mode="sta"},{mode="ap-wds"},{mode="sta-wds"})
end
elseif e and not t then
encr:value("psk","WPA-PSK",{mode="ap"},{mode="ap-wds"})
encr:value("psk2","WPA2-PSK",{mode="ap"},{mode="ap-wds"})
encr:value("psk-mixed","WPA-PSK/WPA2-PSK Mixed Mode",{mode="ap"},{mode="ap-wds"})
if o then
encr:value("wpa","WPA-EAP",{mode="ap"},{mode="ap-wds"})
encr:value("wpa2","WPA2-EAP",{mode="ap"},{mode="ap-wds"})
end
encr.description=translate(
"WPA-Encryption requires wpa_supplicant (for client mode) or hostapd (for AP "..
"and ad-hoc mode) to be installed."
)
elseif not e and t then
encr:value("psk","WPA-PSK",{mode="sta"},{mode="sta-wds"},{mode="adhoc"})
encr:value("psk2","WPA2-PSK",{mode="sta"},{mode="sta-wds"},{mode="adhoc"})
encr:value("psk-mixed","WPA-PSK/WPA2-PSK Mixed Mode",{mode="sta"},{mode="sta-wds"},{mode="adhoc"})
if a then
encr:value("wpa","WPA-EAP",{mode="sta"},{mode="sta-wds"})
encr:value("wpa2","WPA2-EAP",{mode="sta"},{mode="sta-wds"})
end
encr.description=translate(
"WPA-Encryption requires wpa_supplicant (for client mode) or hostapd (for AP "..
"and ad-hoc mode) to be installed."
)
else
encr.description=translate(
"WPA-Encryption requires wpa_supplicant (for client mode) or hostapd (for AP "..
"and ad-hoc mode) to be installed."
)
end
elseif e=="broadcom"then
encr:value("psk","WPA-PSK")
encr:value("psk2","WPA2-PSK")
encr:value("psk+psk2","WPA-PSK/WPA2-PSK Mixed Mode")
elseif e=="rtwifi"or e=="mt_dbdc"then
encr:value("psk","WPA-PSK")
encr:value("psk2","WPA2-PSK")
encr:value("psk-mixed","WPA-PSK/WPA2-PSK Mixed Mode")
encr_wds=s:taboption("encryption",ListValue,"wdsenctype",translate("Encryption"))
encr_wds:depends({mode="wds"})
encr_wds:value("NONE",translate("No Encryption"))
encr_wds:value("WEP","WEP Shared Key")
encr_wds:value("TKIP","WPA-PSK/WPA2-PSK TKIP")
encr_wds:value("AES","WPA-PSK/WPA2-PSK AES")
wdskey=s:taboption("encryption",Value,"wdskey",translate("Key"))
wdskey.password=true
wdskey:depends("wdsenctype","WEP")
wdskey:depends("wdsenctype","TKIP")
wdskey:depends("wdsenctype","AES")
end
auth_server=s:taboption("encryption",Value,"auth_server",translate("Radius-Authentication-Server"))
auth_server:depends({mode="ap",encryption="wpa"})
auth_server:depends({mode="ap",encryption="wpa2"})
auth_server:depends({mode="ap-wds",encryption="wpa"})
auth_server:depends({mode="ap-wds",encryption="wpa2"})
auth_server.rmempty=true
auth_server.datatype="host(0)"
auth_port=s:taboption("encryption",Value,"auth_port",translate("Radius-Authentication-Port"),translatef("Default %d",1812))
auth_port:depends({mode="ap",encryption="wpa"})
auth_port:depends({mode="ap",encryption="wpa2"})
auth_port:depends({mode="ap-wds",encryption="wpa"})
auth_port:depends({mode="ap-wds",encryption="wpa2"})
auth_port.rmempty=true
auth_port.datatype="port"
auth_secret=s:taboption("encryption",Value,"auth_secret",translate("Radius-Authentication-Secret"))
auth_secret:depends({mode="ap",encryption="wpa"})
auth_secret:depends({mode="ap",encryption="wpa2"})
auth_secret:depends({mode="ap-wds",encryption="wpa"})
auth_secret:depends({mode="ap-wds",encryption="wpa2"})
auth_secret.rmempty=true
auth_secret.password=true
acct_server=s:taboption("encryption",Value,"acct_server",translate("Radius-Accounting-Server"))
acct_server:depends({mode="ap",encryption="wpa"})
acct_server:depends({mode="ap",encryption="wpa2"})
acct_server:depends({mode="ap-wds",encryption="wpa"})
acct_server:depends({mode="ap-wds",encryption="wpa2"})
acct_server.rmempty=true
acct_server.datatype="host(0)"
acct_port=s:taboption("encryption",Value,"acct_port",translate("Radius-Accounting-Port"),translatef("Default %d",1813))
acct_port:depends({mode="ap",encryption="wpa"})
acct_port:depends({mode="ap",encryption="wpa2"})
acct_port:depends({mode="ap-wds",encryption="wpa"})
acct_port:depends({mode="ap-wds",encryption="wpa2"})
acct_port.rmempty=true
acct_port.datatype="port"
acct_secret=s:taboption("encryption",Value,"acct_secret",translate("Radius-Accounting-Secret"))
acct_secret:depends({mode="ap",encryption="wpa"})
acct_secret:depends({mode="ap",encryption="wpa2"})
acct_secret:depends({mode="ap-wds",encryption="wpa"})
acct_secret:depends({mode="ap-wds",encryption="wpa2"})
acct_secret.rmempty=true
acct_secret.password=true
wpakey=s:taboption("encryption",Value,"_wpa_key",translate("Key"))
wpakey:depends("encryption","psk")
wpakey:depends("encryption","psk2")
wpakey:depends("encryption","psk+psk2")
wpakey:depends("encryption","psk-mixed")
wpakey.datatype="wpakey"
wpakey.rmempty=true
wpakey.password=true
wpakey.cfgvalue=function(t,e,t)
local e=m.uci:get("wireless",e,"key")
if e=="1"or e=="2"or e=="3"or e=="4"then
return nil
end
return e
end
wpakey.write=function(t,e,a)
t.map.uci:set("wireless",e,"key",a)
t.map.uci:delete("wireless",e,"key1")
end
wepslot=s:taboption("encryption",ListValue,"_wep_key",translate("Used Key Slot"))
wepslot:depends("encryption","wep-open")
wepslot:depends("encryption","wep-shared")
wepslot:value("1",translatef("Key #%d",1))
wepslot:value("2",translatef("Key #%d",2))
wepslot:value("3",translatef("Key #%d",3))
wepslot:value("4",translatef("Key #%d",4))
wepslot.cfgvalue=function(t,e)
local e=tonumber(m.uci:get("wireless",e,"key"))
if not e or e<1 or e>4 then
return 1
end
return e
end
wepslot.write=function(a,t,e)
a.map.uci:set("wireless",t,"key",e)
end
local t
for e=1,4 do
wepkey=s:taboption("encryption",Value,"key"..e,translatef("Key #%d",e))
wepkey:depends("encryption","wep-open")
wepkey:depends("encryption","wep-shared")
wepkey.datatype="wepkey"
wepkey.rmempty=true
wepkey.password=true
function wepkey.write(t,a,e)
if e and(#e==5 or#e==13)then
e="s:"..e
end
return Value.write(t,a,e)
end
end
if e=="rtwifi"or e=="mt_dbdc"then
wps=s:taboption("encryption",ListValue,"wps",translate("WPS Mode"))
wps:value("",translate("disable"))
wps:value("pbc",translate("PBC"))
wps:depends({mode="ap",encryption="psk"})
wps:depends({mode="ap",encryption="psk2"})
wps:depends({mode="ap",encryption="psk-mixed"})
end
if e=="qcawifi"or e=="mac80211"or e=="prism2"then
local e=(os.execute("hostapd -v11r 2>/dev/null || hostapd -veap 2>/dev/null")==0)
ieee80211r=s:taboption("encryption",Flag,"ieee80211r",
translate("802.11r Fast Transition"),
translate("Enables fast roaming among access points that belong "..
"to the same Mobility Domain"))
ieee80211r:depends({mode="ap",encryption="wpa"})
ieee80211r:depends({mode="ap",encryption="wpa2"})
ieee80211r:depends({mode="ap-wds",encryption="wpa"})
ieee80211r:depends({mode="ap-wds",encryption="wpa2"})
if e then
ieee80211r:depends({mode="ap",encryption="psk"})
ieee80211r:depends({mode="ap",encryption="psk2"})
ieee80211r:depends({mode="ap",encryption="psk-mixed"})
end
ieee80211r.rmempty=true
nasid=s:taboption("encryption",Value,"nasid",translate("NAS ID"),
translate("Used for two different purposes: RADIUS NAS ID and "..
"802.11r R0KH-ID. Not needed with normal WPA(2)-PSK."))
nasid:depends({mode="ap",encryption="wpa"})
nasid:depends({mode="ap",encryption="wpa2"})
nasid:depends({mode="ap-wds",encryption="wpa"})
nasid:depends({mode="ap-wds",encryption="wpa2"})
nasid:depends({ieee80211r="1"})
nasid.rmempty=true
mobility_domain=s:taboption("encryption",Value,"mobility_domain",
translate("Mobility Domain"),
translate("4-character hexadecimal ID"))
mobility_domain:depends({ieee80211r="1"})
mobility_domain.placeholder="4f57"
mobility_domain.datatype="and(hexstring,rangelength(4,4))"
mobility_domain.rmempty=true
r0_key_lifetime=s:taboption("encryption",Value,"r0_key_lifetime",
translate("R0 Key Lifetime"),translate("minutes"))
r0_key_lifetime:depends({ieee80211r="1"})
r0_key_lifetime.placeholder="10000"
r0_key_lifetime.datatype="uinteger"
r0_key_lifetime.rmempty=true
r1_key_holder=s:taboption("encryption",Value,"r1_key_holder",
translate("R1 Key Holder"),
translate("6-octet identifier as a hex string - no colons"))
r1_key_holder:depends({ieee80211r="1"})
r1_key_holder.placeholder="00004f577274"
r1_key_holder.datatype="and(hexstring,rangelength(12,12))"
r1_key_holder.rmempty=true
reassociation_deadline=s:taboption("encryption",Value,"reassociation_deadline",
translate("Reassociation Deadline"),
translate("time units (TUs / 1.024 ms) [1000-65535]"))
reassociation_deadline:depends({ieee80211r="1"})
reassociation_deadline.placeholder="1000"
reassociation_deadline.datatype="range(1000,65535)"
reassociation_deadline.rmempty=true
pmk_r1_push=s:taboption("encryption",Flag,"pmk_r1_push",translate("PMK R1 Push"))
pmk_r1_push:depends({ieee80211r="1"})
pmk_r1_push.placeholder="0"
pmk_r1_push.rmempty=true
r0kh=s:taboption("encryption",DynamicList,"r0kh",translate("External R0 Key Holder List"),
translate("List of R0KHs in the same Mobility Domain. "..
"<br />Format: MAC-address,NAS-Identifier,128-bit key as hex string. "..
"<br />This list is used to map R0KH-ID (NAS Identifier) to a destination "..
"MAC address when requesting PMK-R1 key from the R0KH that the STA "..
"used during the Initial Mobility Domain Association."))
r0kh:depends({ieee80211r="1"})
r0kh.rmempty=true
r1kh=s:taboption("encryption",DynamicList,"r1kh",translate("External R1 Key Holder List"),
translate("List of R1KHs in the same Mobility Domain. "..
"<br />Format: MAC-address,R1KH-ID as 6 octets with colons,128-bit key as hex string. "..
"<br />This list is used to map R1KH-ID to a destination MAC address "..
"when sending PMK-R1 key from the R0KH. This is also the "..
"list of authorized R1KHs in the MD that can request PMK-R1 keys."))
r1kh:depends({ieee80211r="1"})
r1kh.rmempty=true
eaptype=s:taboption("encryption",ListValue,"eap_type",translate("EAP-Method"))
eaptype:value("tls","TLS")
eaptype:value("ttls","TTLS")
eaptype:value("peap","PEAP")
eaptype:value("fast","FAST")
eaptype:depends({mode="sta",encryption="wpa"})
eaptype:depends({mode="sta",encryption="wpa2"})
eaptype:depends({mode="sta-wds",encryption="wpa"})
eaptype:depends({mode="sta-wds",encryption="wpa2"})
cacert=s:taboption("encryption",FileUpload,"ca_cert",translate("Path to CA-Certificate"))
cacert:depends({mode="sta",encryption="wpa"})
cacert:depends({mode="sta",encryption="wpa2"})
cacert:depends({mode="sta-wds",encryption="wpa"})
cacert:depends({mode="sta-wds",encryption="wpa2"})
cacert.rmempty=true
clientcert=s:taboption("encryption",FileUpload,"client_cert",translate("Path to Client-Certificate"))
clientcert:depends({mode="sta",eap_type="tls",encryption="wpa"})
clientcert:depends({mode="sta",eap_type="tls",encryption="wpa2"})
clientcert:depends({mode="sta-wds",eap_type="tls",encryption="wpa"})
clientcert:depends({mode="sta-wds",eap_type="tls",encryption="wpa2"})
privkey=s:taboption("encryption",FileUpload,"priv_key",translate("Path to Private Key"))
privkey:depends({mode="sta",eap_type="tls",encryption="wpa2"})
privkey:depends({mode="sta",eap_type="tls",encryption="wpa"})
privkey:depends({mode="sta-wds",eap_type="tls",encryption="wpa2"})
privkey:depends({mode="sta-wds",eap_type="tls",encryption="wpa"})
privkeypwd=s:taboption("encryption",Value,"priv_key_pwd",translate("Password of Private Key"))
privkeypwd:depends({mode="sta",eap_type="tls",encryption="wpa2"})
privkeypwd:depends({mode="sta",eap_type="tls",encryption="wpa"})
privkeypwd:depends({mode="sta-wds",eap_type="tls",encryption="wpa2"})
privkeypwd:depends({mode="sta-wds",eap_type="tls",encryption="wpa"})
privkeypwd.rmempty=true
privkeypwd.password=true
auth=s:taboption("encryption",ListValue,"auth",translate("Authentication"))
auth:value("PAP","PAP",{eap_type="ttls"})
auth:value("CHAP","CHAP",{eap_type="ttls"})
auth:value("MSCHAP","MSCHAP",{eap_type="ttls"})
auth:value("MSCHAPV2","MSCHAPv2",{eap_type="ttls"})
auth:value("EAP-GTC")
auth:value("EAP-MD5")
auth:value("EAP-MSCHAPV2")
auth:value("EAP-TLS")
auth:depends({mode="sta",eap_type="fast",encryption="wpa2"})
auth:depends({mode="sta",eap_type="fast",encryption="wpa"})
auth:depends({mode="sta",eap_type="peap",encryption="wpa2"})
auth:depends({mode="sta",eap_type="peap",encryption="wpa"})
auth:depends({mode="sta",eap_type="ttls",encryption="wpa2"})
auth:depends({mode="sta",eap_type="ttls",encryption="wpa"})
auth:depends({mode="sta-wds",eap_type="fast",encryption="wpa2"})
auth:depends({mode="sta-wds",eap_type="fast",encryption="wpa"})
auth:depends({mode="sta-wds",eap_type="peap",encryption="wpa2"})
auth:depends({mode="sta-wds",eap_type="peap",encryption="wpa"})
auth:depends({mode="sta-wds",eap_type="ttls",encryption="wpa2"})
auth:depends({mode="sta-wds",eap_type="ttls",encryption="wpa"})
cacert2=s:taboption("encryption",FileUpload,"ca_cert2",translate("Path to inner CA-Certificate"))
cacert2:depends({mode="sta",auth="EAP-TLS",encryption="wpa"})
cacert2:depends({mode="sta",auth="EAP-TLS",encryption="wpa2"})
cacert2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa"})
cacert2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa2"})
clientcert2=s:taboption("encryption",FileUpload,"client_cert2",translate("Path to inner Client-Certificate"))
clientcert2:depends({mode="sta",auth="EAP-TLS",encryption="wpa"})
clientcert2:depends({mode="sta",auth="EAP-TLS",encryption="wpa2"})
clientcert2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa"})
clientcert2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa2"})
privkey2=s:taboption("encryption",FileUpload,"priv_key2",translate("Path to inner Private Key"))
privkey2:depends({mode="sta",auth="EAP-TLS",encryption="wpa"})
privkey2:depends({mode="sta",auth="EAP-TLS",encryption="wpa2"})
privkey2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa"})
privkey2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa2"})
privkeypwd2=s:taboption("encryption",Value,"priv_key2_pwd",translate("Password of inner Private Key"))
privkeypwd2:depends({mode="sta",auth="EAP-TLS",encryption="wpa"})
privkeypwd2:depends({mode="sta",auth="EAP-TLS",encryption="wpa2"})
privkeypwd2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa"})
privkeypwd2:depends({mode="sta-wds",auth="EAP-TLS",encryption="wpa2"})
privkeypwd2.rmempty=true
privkeypwd2.password=true
identity=s:taboption("encryption",Value,"identity",translate("Identity"))
identity:depends({mode="sta",eap_type="fast",encryption="wpa2"})
identity:depends({mode="sta",eap_type="fast",encryption="wpa"})
identity:depends({mode="sta",eap_type="peap",encryption="wpa2"})
identity:depends({mode="sta",eap_type="peap",encryption="wpa"})
identity:depends({mode="sta",eap_type="ttls",encryption="wpa2"})
identity:depends({mode="sta",eap_type="ttls",encryption="wpa"})
identity:depends({mode="sta-wds",eap_type="fast",encryption="wpa2"})
identity:depends({mode="sta-wds",eap_type="fast",encryption="wpa"})
identity:depends({mode="sta-wds",eap_type="peap",encryption="wpa2"})
identity:depends({mode="sta-wds",eap_type="peap",encryption="wpa"})
identity:depends({mode="sta-wds",eap_type="ttls",encryption="wpa2"})
identity:depends({mode="sta-wds",eap_type="ttls",encryption="wpa"})
identity:depends({mode="sta",eap_type="tls",encryption="wpa2"})
identity:depends({mode="sta",eap_type="tls",encryption="wpa"})
identity:depends({mode="sta-wds",eap_type="tls",encryption="wpa2"})
identity:depends({mode="sta-wds",eap_type="tls",encryption="wpa"})
anonymous_identity=s:taboption("encryption",Value,"anonymous_identity",translate("Anonymous Identity"))
anonymous_identity:depends({mode="sta",eap_type="fast",encryption="wpa2"})
anonymous_identity:depends({mode="sta",eap_type="fast",encryption="wpa"})
anonymous_identity:depends({mode="sta",eap_type="peap",encryption="wpa2"})
anonymous_identity:depends({mode="sta",eap_type="peap",encryption="wpa"})
anonymous_identity:depends({mode="sta",eap_type="ttls",encryption="wpa2"})
anonymous_identity:depends({mode="sta",eap_type="ttls",encryption="wpa"})
anonymous_identity:depends({mode="sta-wds",eap_type="fast",encryption="wpa2"})
anonymous_identity:depends({mode="sta-wds",eap_type="fast",encryption="wpa"})
anonymous_identity:depends({mode="sta-wds",eap_type="peap",encryption="wpa2"})
anonymous_identity:depends({mode="sta-wds",eap_type="peap",encryption="wpa"})
anonymous_identity:depends({mode="sta-wds",eap_type="ttls",encryption="wpa2"})
anonymous_identity:depends({mode="sta-wds",eap_type="ttls",encryption="wpa"})
anonymous_identity:depends({mode="sta",eap_type="tls",encryption="wpa2"})
anonymous_identity:depends({mode="sta",eap_type="tls",encryption="wpa"})
anonymous_identity:depends({mode="sta-wds",eap_type="tls",encryption="wpa2"})
anonymous_identity:depends({mode="sta-wds",eap_type="tls",encryption="wpa"})
password=s:taboption("encryption",Value,"password",translate("Password"))
password:depends({mode="sta",eap_type="fast",encryption="wpa2"})
password:depends({mode="sta",eap_type="fast",encryption="wpa"})
password:depends({mode="sta",eap_type="peap",encryption="wpa2"})
password:depends({mode="sta",eap_type="peap",encryption="wpa"})
password:depends({mode="sta",eap_type="ttls",encryption="wpa2"})
password:depends({mode="sta",eap_type="ttls",encryption="wpa"})
password:depends({mode="sta-wds",eap_type="fast",encryption="wpa2"})
password:depends({mode="sta-wds",eap_type="fast",encryption="wpa"})
password:depends({mode="sta-wds",eap_type="peap",encryption="wpa2"})
password:depends({mode="sta-wds",eap_type="peap",encryption="wpa"})
password:depends({mode="sta-wds",eap_type="ttls",encryption="wpa2"})
password:depends({mode="sta-wds",eap_type="ttls",encryption="wpa"})
password.rmempty=true
password.password=true
end
if e=="mac80211"then
local e=(os.execute("hostapd -v11w 2>/dev/null || hostapd -veap 2>/dev/null")==0)
if e then
ieee80211w=s:taboption("encryption",ListValue,"ieee80211w",
translate("802.11w Management Frame Protection"),
translate("Requires the 'full' version of wpad/hostapd "..
"and support from the wifi driver <br />(as of Feb 2017: "..
"ath9k and ath10k, in LEDE also mwlwifi and mt76)"))
ieee80211w.default=""
ieee80211w.rmempty=true
ieee80211w:value("",translate("Disabled (default)"))
ieee80211w:value("1",translate("Optional"))
ieee80211w:value("2",translate("Required"))
ieee80211w:depends({mode="ap",encryption="wpa2"})
ieee80211w:depends({mode="ap-wds",encryption="wpa2"})
ieee80211w:depends({mode="ap",encryption="psk2"})
ieee80211w:depends({mode="ap",encryption="psk-mixed"})
ieee80211w:depends({mode="ap-wds",encryption="psk2"})
ieee80211w:depends({mode="ap-wds",encryption="psk-mixed"})
max_timeout=s:taboption("encryption",Value,"ieee80211w_max_timeout",
translate("802.11w maximum timeout"),
translate("802.11w Association SA Query maximum timeout"))
max_timeout:depends({ieee80211w="1"})
max_timeout:depends({ieee80211w="2"})
max_timeout.datatype="uinteger"
max_timeout.placeholder="1000"
max_timeout.rmempty=true
retry_timeout=s:taboption("encryption",Value,"ieee80211w_retry_timeout",
translate("802.11w retry timeout"),
translate("802.11w Association SA Query retry timeout"))
retry_timeout:depends({ieee80211w="1"})
retry_timeout:depends({ieee80211w="2"})
retry_timeout.datatype="uinteger"
retry_timeout.placeholder="201"
retry_timeout.rmempty=true
end
end
if e=="qcawifi"or e=="mac80211"or e=="prism2"then
local t=d.access("/usr/sbin/wpa_supplicant")
local e=d.access("/usr/sbin/hostapd_cli")
if e and t then
wps=s:taboption("encryption",Flag,"wps_pushbutton",translate("Enable WPS pushbutton, requires WPA(2)-PSK"))
wps.enabled="1"
wps.disabled="0"
wps.rmempty=false
wps:depends("encryption","psk")
wps:depends("encryption","psk2")
wps:depends("encryption","psk-mixed")
end
end
return m
